<template>
  <form @submit="onSubmit">
    <TextField label="عنوان" dark v-model="title" id="category-title-field" class="field" :error="titleError"/>
    <TextField label="توضیحات (برای بهبود سئو)" dark v-model="description" id="category-description-field" class="field" :error="descriptionError"/>
    <Button size="lg" type="contained" color="primary" class="button" :disabled="disabled" @click.native="onSubmit">{{ ButtonLabel }}</Button>
  </form>
</template>

<script>
import Button from "@/components/base/Button";
import TextField from "@/components/base/TextField";

export default {
  name: "CreateCategoryForm",
  components: {
    Button,
    TextField
  },
  data() {
    return {
      oldTitle: this.category ? this.category.title : '',
      oldDescription: this.category ? this.category.details : '',
      title: this.category ? this.category.title : '',
      description: this.category ? this.category.details : ''
    }
  },
  props: {
    category: {
      type: Object,
      default: null
    }
  },
  methods: {
    onSubmit(e) {
      e.preventDefault();
      if (this.category) {
        this.update();
      } else {
        this.create();
      }
    },
    update() {
      if (this.canUpdate) {
        this.$store.dispatch('shop/updateCategory', {
          data: {
            title: this.title,
            details: this.description,
          },
          id: this.category.id,
          token: this.$store.getters['auth/getToken']
        }).then(response => {
          if (response.status === 200) {
            this.$store.dispatch('notifications/push', {
              message: 'دسته بندی با موفقیت بروزرسانی شد.',
              light: true,
              type: 'success',
              timeout: 2500
            });
            this.oldTitle = this.title;
            this.oldDescription = this.description;
            this.$emit('update', response.data.data);
          } else if (response.status === 400) {
            this.$store.dispatch('notifications/push', {
              message: 'ورودی های خود را کنترل کنید.',
              type: 'error',
              timeout: 3500
            });
          } else {
            this.$store.dispatch('notifications/push', {
              message: 'خطا در اتصال به سرور! لطفا دقایقی دیگر دوباره امتحان کنید.',
              type: 'error',
              timeout: 3500
            });
          }
        }).catch(error => {
          this.$store.dispatch('notifications/push', {
            message: 'خطا در اتصال به سرور! لطفا دقایقی دیگر دوباره امتحان کنید.',
            type: 'error',
            timeout: 3500
          });
        });
      } else {
        this.$store.dispatch('notifications/push', {
          message: 'لطفا ورودی های خود را کنترل کنید!',
          light: true,
          type: 'warning',
          timeout: 2500
        });
      }
    },
    create() {
      if (this.canCreate) {
        this.$store.dispatch('shop/createCategory', {
          data: {
            title: this.title,
            details: this.description
          },
          token: this.$store.getters['auth/getToken']
        }).then(response => {
          if (response.status === 201) {
            this.$store.dispatch('notifications/push', {
              message: 'دسته بندی با موفقیت ایجاد شد.',
              light: true,
              type: 'success',
              timeout: 2500
            });
            this.$emit('create', response.data.data);
          } else if (response.status === 400) {
            this.$store.dispatch('notifications/push', {
              message: 'ورودی های خود را کنترل کنید.',
              type: 'error',
              timeout: 3500
            });
          } else {
            this.$store.dispatch('notifications/push', {
              message: 'خطا در اتصال به سرور! لطفا دقایقی دیگر دوباره امتحان کنید.',
              type: 'error',
              timeout: 3500
            });
          }
        }).catch(error => {
          this.$store.dispatch('notifications/push', {
            message: 'خطا در اتصال به سرور! لطفا دقایقی دیگر دوباره امتحان کنید.',
            type: 'error',
            timeout: 3500
          });
        });
      } else {
        this.$store.dispatch('notifications/push', {
          message: 'لطفا ورودی های خود را کنترل کنید!',
          light: true,
          type: 'warning',
          timeout: 2500
        });
      }
    }
  },
  computed: {
    hasChanged() {
      return this.oldTitle !== this.title || this.oldDescription !== this.description ? true : false;
    },
    canUpdate() {
      return this.hasChanged && this.isFormValid ? true : false;
    },
    canCreate() {
      return this.isFormFilled && this.isFormValid ? true : false;
    },
    isFormValid() {
      return !this.titleError && !this.descriptionError ? true : false;
    },
    isFormFilled() {
      return this.title && this.description ? true : false;
    },
    disabled() {
      if (this.category) {
        return this.isFormFilled && this.hasChanged ? false : true;
      } else {
        return this.isFormFilled ? false : true;
      }
    },
    titleError() {
      const regex = /^[آ-ی ء چ]+$/;
      if (!this.title) {
        return "";
      } else if (!regex.test(this.title)) {
        return "فقط از حروف فارسی استفاده کنید!";
      } else {
        return "";
      }
    },
    descriptionError() {
      const regex = /^[آ-ی ء چ]+$/;
      if (!this.description) {
        return "";
      } else if (!regex.test(this.description)) {
        return "فقط از حروف فارسی استفاده کنید!";
      } else {
        return "";
      }
    },
    ButtonLabel() {
      return this.category ? "بروزرسانی" : "ثبت";
    }
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.field
  margin-bottom $sm

.button
  width 100%
</style>